routes/web.php
<?php

use App\Http\Controllers\Auth\AuthController;
use App\Http\Controllers\Dashboard\DashboardController;
use App\Http\Controllers\lab\LabController;
use App\Http\Controllers\lab\PasienController as LabPasienController;
use App\Http\Controllers\lab\ResultLabController;
use App\Models\Pasien;
use App\Http\Controllers\rawatjalan\KunjunganController;
use App\Http\Controllers\Pasien\PasienController;
use App\Http\Controllers\RekamMedis\EntryKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatMedisController;
use App\Http\Controllers\Pembayaran\PembayaranController;
use App\Http\Controllers\Pharmacy\PharmacyController;
use Illuminate\Support\Facades\Route;

Route::controller(AuthController::class)->group(function () {
    Route::get('/', 'index')->name('login');
    Route::post('/', 'login')->name('loginPost');
    Route::get('/logout', 'logout')->name('logout');
});

Route::middleware('authenticated')->group(function () {
    // Dashboard Route
    Route::middleware('auth-roles:staff,dokter,admin,teknisi,perawat')->group(function () {
        // Pharmacy Route
        Route::prefix('pharmacy')->name('pharmacy.')->group(function () {
            Route::controller(PharmacyController::class)->group(function () {
                // prescription area
                Route::get('/receipt/{id}', 'getPrescriptionView')->name('prescriptionView');
                Route::get('/receipt/{visitId}/detail/{id}', 'getPrescriptionDetailView')->name('prescriptionDetail');
                Route::post('/receipt/detail', 'createDrugInPrescription')->name('createDrugInPrescription');
                Route::post('/receipt//detail/destroy/{id}', 'destroyDrugInPrescription')->name('destroyDrugInPrescription');
                Route::post('/receipt/detail/update/', 'updateDrugInPrescription')->name('updateDrugInPrescription');
                Route::get('/receipt/checkout/{id}/{visitId}', 'checkoutPrescription')->name('checkoutPrescription');

                // drug area
                Route::get('/medicine', 'listMedicine')->name('listMedicine');
                Route::get('/medicine/{id}', 'detailMedicine')->name('detailMedicine');
                Route::post('/medicine/{id}/destroy', 'destroyDrug')->name('destroyMedicine');
                Route::post('/medicine', 'createDrug')->name('createMedicine');
                Route::post('/medicine/{id}', 'updateDrug')->name('updateMedicine');
                Route::post('/medicine/{id}/update', 'updateDrugStock')->name('updateMedicineStock');
                Route::get('/medicine/export', 'downloadDrugExcel')->name('downloadDrugExcel');
            });
        });


        // Dashboard
        Route::controller(DashboardController::class)->group(function () {
            Route::get('/dashboard', 'index')->name('dashboard');
        });

        // START RJ
        // get data all detail kunjungan RJ
        Route::get('/rawat-jalan/detail-kunjungan', [KunjunganController::class, 'index'])->name('rawatjalan.index');

        // get data pemeriksaan lab and apotek
        Route::get('/rawat-jalan/set-data-pemeriksaan', [KunjunganController::class, 'pemeriksaan'])->name('rawatjalan.pemeriksaan');

        // get url add diagnosa
        Route::get('/rawat-jalan/{detailkunjungan}/add-diagnosa', [KunjunganController::class, 'adddiagnosa'])->name('rawatjalan.adddiagnosa');

        // patch data diagnosa
        Route::patch('/rawat-jalan/{detailkunjungan}/add-diagnosa/success-added', [KunjunganController::class, 'adddiagnosaAdded'])->name('rawatjalan.adddiagnosaAdded');

        // get url add data's (dokter,room,poli)
        Route::get('/rawat-jalan/detail-kunjungan/{detailkunjungan}/add-data-result', [KunjunganController::class, 'show'])->name('rawatjalan.show');

        // patch data results
        Route::patch('/rawat-jalan/detail-kunjungan/{detailkunjungan}/added-data-result', [KunjunganController::class, 'store'])->name('rawatjalan.store');

        // get sorting belum pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/belum-pemeriksaan', [KunjunganController::class, 'sortingBelumPemeriksaan'])->name('rawatjalan.belumPemeriksaan');

        // get sorting sudah pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/sudah-pemeriksaan', [KunjunganController::class, 'sortingSudahPemeriksaan'])->name('rawatjalan.sudahPemeriksaan');

        // get edit data page n fetch data 
        Route::get('/rawat-jalan/update-kunjungan/{detailkunjungan}/edit-datas', [KunjunganController::class, 'edit'])->name('rawatjalan.edit');

        // Update data
        Route::patch('/rawat-jalan/update-kunjungan/{detailkunjungan}/update-datas', [KunjunganController::class, 'update'])->name('rawatjalan.update');

        // delete data kunjungan 
        Route::delete('rawat-jalan/deleted/{detailkunjungan}/datas', [KunjunganController::class, 'destroy'])->name('rawatjalan.destroy');
    });

    Route::controller(PasienController::class)
        ->prefix('pasien')
        ->name('pasien.')
        ->group(function () {
            Route::get('/', 'index')->name('index');
            Route::get('/create', 'create')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/edit/{id}', 'edit')->name('edit');
            Route::post('/update/{id}', 'update')->name('update');
            Route::delete('/delete/{id}', 'delete')->name('delete');
        });

    // example when group route with the role
    Route::middleware('auth-roles:admin')->group(function () {
        Route::get('/onlyadmin', function () {
            return 'Only Admin';
        });
        Route::get('/lab', [LabController::class, 'index'])->name('lab.index');
        Route::get('/lab/create', [LabController::class, 'create'])->name('lab.create');
        Route::get('/lab/edit/{lab}', [LabController::class, 'edit'])->name('lab.edit');
        Route::put('/lab/edit/{lab}', [LabController::class, 'update'])->name('lab.update');
        Route::delete('/lab/{lab}', [LabController::class, 'destroy'])->name('lab.destroy');
        Route::post('/lab', [LabController::class, 'store'])->name('lab.store');

        Route::controller(ResultLabController::class)->group(function () {
            Route::get('/result-lab', 'index')->name('resultLab.index');
            Route::get('/result-lab/create', 'create')->name('resultLab.create');
            Route::post('/result-lab', 'store')->name('resultLab.store');
            Route::get('/result-lab/{resultLab}', 'show')->name('resultLab.show');
            Route::delete('/result-lab/{resultLab}', 'destroy')->name('resultLab.destroy');
            Route::get('/result-lab/edit/{resultLab}', 'edit')->name('resultLab.edit');
            Route::put('/result-lab/{resultLab}', 'update')->name('resultLab.update');
            Route::get('/result-lab/download/{resultLab}', 'download')->name('resultLab.download');
        });
    });

    Route::prefix('/pembayaran')->name('pembayaran')->group(function () {
        Route::get('/', [PembayaranController::class, 'index']);

        Route::prefix('/transaksi')->name('-transaksi')->group(function () {
            Route::get('/', [PembayaranController::class, 'transaksi']);
            Route::get('/{page?}', [PembayaranController::class, 'transaksi'])->name('-pagination');
            Route::post('/confirmation/{id?}', [PembayaranController::class, 'update'])->name('-update');
        });

        Route::prefix('/riwayat')->name('-riwayat')->group(function () {
            Route::get('/', [PembayaranController::class, 'riwayat'])->name('-transaksi');
            Route::get('/cetak/{id?}', [PembayaranController::class, 'cetak'])->name('-cetak');
        });
    });
});

Route::view('/example', 'example.example')->name('example');
Route::prefix('rekam-medis')->group(function () {
    Route::controller(EntryKunjunganController::class)
        ->prefix('/entry-kunjungan')
        ->name('entry-kunjungan.')
        ->group(function () {
            Route::get('/', 'showEntryKunjungan')->name('index');
            Route::get('/create', 'createEntryKunjungan')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/{id}', 'details')->name('detail');
        });
    Route::controller(RiwayatKunjunganController::class)
        ->prefix('/riwayat-kunjungan')
        ->name('riwayat-kunjungan.')
        ->group(function () {
            Route::get('/', 'showRiwayatKunjungan')->name('index');
            Route::get('/detail', 'showDetailRiwayatKunjungan')->name('detail');
        });
    Route::controller(RiwayatMedisController::class)
        ->prefix('/riwayat-medis')
        ->name('riwayat-medis.')
        ->group(function () {
            Route::get('/', 'showRiwayatMedis')->name('index');
        });
});

app/Models/Pasien.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Pasien extends Model
{
    use HasFactory;
    protected $guarded = ['id'];

}

app/Http/Controllers/API/PasienController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Pasien;

class PasienController extends Controller
{
    private Pasien $pasien;

    public function __construct(Pasien $pasien)
    {
        $this->pasien = $pasien;
    }

    public function index(){
        $data = $this->pasien->select('id', 'nama','no_hp', 'jenis_kelamin', 'no_bpjs')->get();
        return response()->json($data, 200);
    }

    public function store(Request $request){

        $validated = $request->validate([
            'nama' => 'required',
            'alamat' => 'required',
            'no_hp' => 'required|numeric',
            'jenis_kelamin' => 'required|in:L,P',
            'tanggal_lahir' => 'required|date',
            'no_ktp' => 'required',
            'no_bpjs' => 'required',
        ]);

        try {
            $this->pasien->create($validated);
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil ditambahkan'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => $th->getMessage()
            ], 500);
        }

    }


    public function show($id){
        return response()->json($this->pasien->find($id), 200);
    }

    public function delete($id){
        try {
            $this->pasien->find($id)->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil dihapus'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => 'Pasien gagal dihapus'
            ]);
        }
    }

    public function update(Request $request, $id){
        $validated = $request->validate([
            'nama' => 'required',
            'alamat' => 'required',
            'no_hp' => 'required|numeric|unique:pasiens,no_hp,'.$id,
            'jenis_kelamin' => 'required|in:L,P',
            'tanggal_lahir' => 'required|date',
            'no_ktp' => 'required|unique:pasiens,no_ktp,'.$id,
            'no_bpjs' => 'required|unique:pasiens,no_bpjs,'.$id,
        ]);

        try {
            $this->pasien->find($id)->update($validated);
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil diupdate'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => $th->getMessage()
            ]);
        }
    }

}

app/Http/Controllers/Pasien/PasienController.php
<?php

namespace App\Http\Controllers\Pasien;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Pasien;

class PasienController extends Controller
{
    private Pasien $pasien;

    public function __construct(Pasien $pasien)
    {
        $this->pasien = $pasien;
    }

    public function index(){
        $pasien = $this->pasien->all();
        return view('pasien.index', compact('pasien'));
    }

    public function create(){
        return view('pasien.create');
    }

    public function store(Request $request){

        $validated = $request->validate([
            'nama' => 'required',
            'alamat' => 'required',
            'no_hp' => 'required|numeric',
            'jenis_kelamin' => 'required|in:L,P',
            'tanggal_lahir' => 'required|date',
            'no_ktp' => 'required',
            'no_bpjs' => 'required',
        ]);

        try {
            $this->pasien->create($validated);
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil ditambahkan'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => $th->getMessage()
            ], 500);
        }

    }


    public function edit($id){
        $pasien = $this->pasien->find($id);
        return view('pasien.edit', compact('pasien'));
    }

    public function delete($id){
        try {
            $this->pasien->find($id)->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil dihapus'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => 'Pasien gagal dihapus'
            ]);
        }
    }

    public function update(Request $request, $id){
        $validated = $request->validate([
            'nama' => 'required',
            'alamat' => 'required',
            'no_hp' => 'required|numeric',
            'jenis_kelamin' => 'required|in:L,P',
            'tanggal_lahir' => 'required|date',
            'no_ktp' => 'required',
            'no_bpjs' => 'required',
        ]);

        try {
            $this->pasien->find($id)->update($validated);
            return response()->json([
                'status' => 'success',
                'message' => 'Pasien berhasil diupdate'
            ]);
        } catch (\Throwable $th) {
            return response()->json([
                'status' => 'error',
                'message' => 'Pasien gagal diupdate'
            ]);
        }
    }

}

resources/views/Pasien/create.blade.php
@extends('templates.master')
@section('title', 'Tambah Pasien')
@section('page-name', 'Tambah Pasien')
@push('styles')

@endpush
@section('content')
    <div class="card">
        <div class="card-header">
            <h4 class="card-title"> Tambah Pasien</h4>
        </div>
        <div class="card-body">
            <form action="{{ route('pasien.store') }}" id="form">
                <div class="form-group">
                    <label for="nama">Nama Pasien</label>
                    <input type="text" name="nama" id="nama" class="form-control">
                </div>
                <div class="form-grpup">
                    <label for="jenkel">Jenis Kelamin</label>
                    <select name="jenis_kelamin" id="jenkel" class="form-control">
                        <option value="" selected disabled>-- Pilih Jenis Kelamin --</option>
                        <option value="L">Laki-laki</option>
                        <option value="P">Perempuan</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="tgl_lahir">Tanggal Lahir</label>
                    <input type="date" name="tanggal_lahir" id="tgl_lahir" class="form-control">
                </div>
                <div class="row">
                    <div class="col">
                        <div class="form-group">
                            <label for="no_hp">No Hp</label>
                            <input type="text" name="no_hp" id="no_hp" class="form-control">
                        </div>
                    </div>
                    <div class="col">
                        <div class="form-group">
                            <label for="no_bpjs">No BPJS</label>
                            <input type="text" name="no_bpjs" id="no_bpjs" class="form-control">
                        </div>
                    </div>
                    <div class="col">
                        <div class="form-group">
                            <label for="no_ktp">No KTP</label>
                            <input type="text" name="no_ktp" id="no_ktp" class="form-control">
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label for="alamat">Alamat</label>
                    <textarea name="alamat" id="" cols="30" rows="5" class="form-control"></textarea>
                </div>

                <button type="submit" class="btn btn-primary">Simpan</button>
            </form>
        </div>
    </div>
@endsection
@push('scripts')
    <script src="https://code.jquery.com/jquery-3.7.1.min.js" integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script>
        $('#form').on('submit', function(e) {
            e.preventDefault();
            $.ajax({
                headers: {
                    'X-CSRF-TOKEN': "{{ csrf_token() }}"
                },
                url: "{{ route('pasien.store') }}",
                method: "POST",
                data: $(this).serialize(),
                success: function(response) {
                    swal({
                        title: "Success",
                        text: response.message,
                        icon: "success",
                    });
                    $('#form').trigger('reset');
                },
                error: function(xhr, status, error) {
                    swal({
                        title: "Error",
                        text: xhr.responseJSON.message,
                        icon: "error",
                    });
                }
            })
        })
    </script>
@endpush

resources/views/Pasien/edit.blade.php
@extends('templates.master')
@section('title', 'Tambah Pasien')
@section('page-name', 'Tambah Pasien')
@push('styles')

@endpush
@section('content')
    <div class="card">
        <div class="card-header">
            <h4 class="card-title"> Edit Pasien</h4>
        </div>
        <div class="card-body">
            <form action="{{ route('pasien.store') }}" id="form">
                <div class="form-group">
                    <label for="nama">Nama Pasien</label>
                    <input type="text" name="nama" id="nama" class="form-control" value="{{ $pasien->nama }}">
                </div>
                <div class="form-grpup">
                    <label for="jenkel">Jenis Kelamin</label>
                    <select name="jenis_kelamin" id="jenkel" class="form-control">
                        <option value="" selected disabled>-- Pilih Jenis Kelamin --</option>
                        <option value="L" {{ $pasien->jenis_kelamin == 'L' ? 'selected' : '' }}>Laki-laki</option>
                        <option value="P" {{ $pasien->jenis_kelamin == 'P' ? 'selected' : '' }}>Perempuan</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="tgl_lahir">Tanggal Lahir</label>
                    <input type="date" name="tanggal_lahir" id="tgl_lahir" class="form-control" value="{{ $pasien->tanggal_lahir }}">
                </div>
                <div class="row">
                    <div class="col">
                        <div class="form-group">
                            <label for="no_hp">No Hp</label>
                            <input type="text" name="no_hp" id="no_hp" class="form-control" value="{{ $pasien->no_hp }}">
                        </div>
                    </div>
                    <div class="col">
                        <div class="form-group">
                            <label for="no_bpjs">No BPJS</label>
                            <input type="text" name="no_bpjs" id="no_bpjs" class="form-control" value="{{ $pasien->no_bpjs }}">
                        </div>
                    </div>
                    <div class="col">
                        <div class="form-group">
                            <label for="no_ktp">No KTP</label>
                            <input type="text" name="no_ktp" id="no_ktp" class="form-control" value="{{ $pasien->no_ktp }}">
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label for="alamat">Alamat</label>
                    <textarea name="alamat" id="" cols="30" rows="5" class="form-control">{{ $pasien->alamat }}</textarea>
                </div>

                <button type="submit" class="btn btn-primary">Simpan</button>
            </form>
        </div>
    </div>
@endsection
@push('scripts')
    <script src="https://code.jquery.com/jquery-3.7.1.min.js" integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script>
        $('#form').on('submit', function(e) {
            e.preventDefault();
            $.ajax({
                headers: {
                    'X-CSRF-TOKEN': "{{ csrf_token() }}"
                },
                url: "{{ route('pasien.update', $pasien->id) }}",
                method: "POST",
                data: $(this).serialize(),
                success: function(response) {
                    swal({
                        title: "Success",
                        text: response.message,
                        icon: "success",
                    }).then((value) => {
                        window.location.href = "{{ route('pasien.index') }}";
                    });
                },
                error: function(xhr, status, error) {
                    swal({
                        title: "Error",
                        text: xhr.responseJSON.message,
                        icon: "error",
                    });
                }
            })
        })
    </script>
@endpush

resources/views/Pasien/index.blade.php
@extends('templates.master')
@section('title', 'Master Pasien')
@section('page-name', 'Master Pasien')
@push('styles')
    <link rel="stylesheet" href={{ asset('assets/extensions/simple-datatables/style.css') }}>
    <link rel="stylesheet" href={{ asset('assets/scss/pages/simple-datatables.scss') }}>
@endpush
@section('content')
    <div class="page-heading">
        <section class="section">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title">
                        Data Pasien
                    </h5>
                </div>
                <div class="card-body">
                    <a href="{{ route('pasien.create') }}" class="btn btn-primary"><i class="bi bi-plus"></i>
                        Data</a>
                    <table class="table table-striped" id="table1">
                        <thead>
                        <tr>
                            <th>No</th>
                            <th>Nama Pasien</th>
                            <th>Jenis Kelamin</th>
                            <th>Tanggal Lahir</th>
                            <th>No Hp</th>
                            <th>Aksi</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach ($pasien as $item)
                                <tr>
                                    <td>{{ $loop->iteration }}</td>
                                    <td>{{ $item->nama }}</td>
                                    <td>{{ $item->jenis_kelamin }}</td>
                                    <td>{{ date('d-m-Y', strtotime($item->tanggal_lahir)) }}</td>
                                    <td>{{ $item->no_hp }}</td>
                                    <td>
                                        <a href="{{ route('pasien.edit', $item->id) }}" class="btn btn-warning text-white"><i
                                                class="bi bi-pencil-square"></i></a>
                                       <button type="button" onclick="deleteData({{ $item->id }})" class="btn btn-danger"><i class="bi bi-trash"></i></button>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

        </section>
    </div>
@endsection
@push('scripts')
    <script src={{ asset ('assets/extensions/simple-datatables/umd/simple-datatables.js') }}></script>
    <script src="https://code.jquery.com/jquery-3.7.1.min.js" integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script>
        let dataTable = new simpleDatatables.DataTable(
            document.getElementById("table1")
        )

        function deleteData(id) {
            swal({
                title: "Apakah anda yakin?",
                text: "Data yang dihapus tidak dapat dikembalikan!",
                icon: "warning",
                buttons: true,
                dangerMode: true,
            }).then((willDelete) => {
                if(willDelete) {
                    $.ajax({
                        headers: {
                            'X-CSRF-TOKEN': '{{ csrf_token() }}'
                        },
                        url: "{{ route('pasien.delete',':id') }}".replace(':id', id),
                        type: "DELETE",
                        success: function(response) {
                            swal({
                                title: "Berhasil!",
                                text: "Data berhasil dihapus!",
                                icon: "success",
                                button: "OK",
                            }).then((value) => {
                                location.reload();
                            });
                        },
                        error: function(response) {
                            swal({
                                title: "Gagal!",
                                text: "Data gagal dihapus!",
                                icon: "error",
                                button: "OK",
                            });
                        }
                    });
                }
            });
        }
    </script>
@endpush